%global version_release CR1
%global version_major 8
%global version_minor 6
%global version_micro 5
%global build_suffix  CR1
%global commitid RHDG_8.6.5.CR1-00208-BOTH
%global serial 70

Name:     jdg-cpp-client
Version:  %{version_major}.%{version_minor}.%{version_micro}
Release:  %{serial}%{?dist}

Summary:        JBoss Data Grid HotRod C++ client
Group:          System Environment/Libraries
License:        ASL 2.0
URL:            https://www.redhat.com/en/technologies/jboss-middleware/data-grid
Source0:        jdg-cpp-client-%{commitid}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake
BuildRequires: doxygen
BuildRequires: valgrind
BuildRequires: java-1.8.0-openjdk-devel swig
%if 0%{?rhel} == 7 || 0%{?rhel} == 8
BuildRequires: openssl-devel
BuildRequires: protobuf-devel protobuf-static
BuildRequires: cyrus-sasl-devel cyrus-sasl-plain cyrus-sasl-md5 cyrus-sasl-gssapi
%endif

%if 0%{?rhel} == 7 || 0%{?rhel} == 8
Requires: openssl-devel
Requires: protobuf-devel protobuf-static
Requires: cyrus-sasl-devel cyrus-sasl-plain cyrus-sasl-md5 cyrus-sasl-gssapi
%endif

%description
JBoss Data Grid HotRod C++ client

%define _unpackaged_files_terminate_build 0

%files
%defattr(-,root,root,-)

%if 0%{?rhel} == 7

%_includedir/infinispan
%_libdir/libhotrod.so
%_libdir/libhotrod.so.*
%_libdir/libhotrod_protobuf.a
%_libdir/libhotrod-static.a
%_docdir/infinispan-hotrod-cpp

%else

%_includedir/infinispan
%_libdir/libhotrod.so
%_libdir/libhotrod.so.*
%_libdir/libhotrod-static.a
%_docdir/infinispan-hotrod-cpp

%endif

%package tests
Summary: JBoss Data Grid C++ client test files

Requires: jdg-cpp-client = %{version}-%{release}

%description tests
JBoss Data Grid C++ client test files

%files tests
%defattr(-,root,root,-)
#%_datadir/tests/*
#%_datadir/tests/simple*
#%_prefix/jni/hotrod-jni.jar
#%_prefix/jni/libhotrod-jni.so
#%if 0%{?rhel} == 7
#%_datadir/tests/*
#%endif

%prep
%setup -q -n jdg-cpp-client-%{commitid}

%build

%ifarch i386
export CXXFLAGS="-march=i686"
%endif

env
mkdir _rpmbuild
pushd _rpmbuild
%if 0%{?rhel} == 6
%cmake  -DCMAKE_BUILD_TYPE=RelWithDebInfo ../rhel6
cmake --build . --target build_dist
%else # building rhel 7 and 8 from the same source (rhel7)
%cmake  -DCMAKE_BUILD_TYPE=RelWithDebInfo ../rhel7
cmake --build . --target build_dist
cmake --build . --target build_native_test
%endif
popd

%install
rm -rf %{buildroot}
pushd _rpmbuild
%make_install
popd

%clean
rm -rf %{buildroot}

%check
# TODO

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%changelog
* Wed Jan 30 2019 Vittorio Rigamonti <vrigamon@redhat.com> - %{version_major}.%{version_minor}.%{version_micro}-51
- no more build_suffix

* Wed Jan 30 2019 Vittorio Rigamonti <vrigamon@redhat.com> - %{version_major}.%{version_minor}.%{version_micro}-50
- removed build_suffix

* Wed Jan 23 2019 Vittorio Rigamonti <vrigamon@redhat.com> - %{version_major}.%{version_minor}.%{version_micro}-48
- CR1 build with cleanup changelog

* Wed Jan 23 2019 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-47
- CR1 Build

* Wed Jan 23 2019 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-46
- 

* Thu Jan 10 2019 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-45
- 

* Fri Dec 28 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-44
- 

* Thu Dec 27 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-43
- 

* Fri Dec 21 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-42
- 

* Fri Dec 21 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-41
- 

* Wed Dec 12 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-40
- 

* Wed Dec 12 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-39
- 

* Wed Dec 12 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-38
- 

* Wed Dec 12 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-37
- 

* Wed Dec 12 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-36
- first build with rhel8

* Wed Dec 05 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-36
- 

* Wed Dec 05 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-36
- 

* Mon Dec 03 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-36
- 

* Fri Nov 30 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-35
- added again build of the test rpm

* Thu Nov 29 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-34
- build of 7.3.0.ER1

* Wed Nov 28 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-33
- repo built by jenkins 7.3.0

* Wed Nov 14 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-32
- 7.3.0.DR4 8th build

* Tue Nov 13 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-31
- 7.3.0.DR4 first build

* Mon Nov 05 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-30
- 7.3.0 test rhel6

* Fri Nov 02 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-29
- Release 7.3.0. First build

* Wed Oct 31 2018 Vittorio Rigamonti <vrigamon@redhat.com> - 8.6.0.ER2-29
- Release 7.3. First build

* Thu Apr 26 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-28
- 

* Tue Apr 10 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-28
- 

* Mon Apr 09 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-27
- 

* Mon Apr 09 2018 Jakub Senko <jsenko@redhat.com> - 8.6.0.ER2-26
- 

* Sun Apr 08 2018 Jakub Senko <jsenko@redhat.com>
- JDG-1276 (HRCPP-434) Fix TLS certificate error handling
- JDG-1395 (HRCPP-425) Fix release transport in fail over
- JDG-1395 (HRCPP-425) add new stats for near cache
- JDG-1507 (HRCPP-429) Improved Add/Rem listener Op robustness
- JDG-1507 (HRCPP-446) Fix race condition in nearCache::getWithVersion
- HRCPP-445 Pass the callback in sasl_client_new and fix MD5
- JDG-1349 (HRCPP-435) Improved remote execute usability
- JDG-1434 remove unrecognized option
- JDG-1402 (HRCPP-439) Fix path for protobuf generate header
- JDG-1310 (HRCPP-432) Added RemoteAsyncAPITest class to the swig test suite
- JDG-1310 (HRCPP-432) Fixed forceReturnValue set up
- JDG-1310 (HRCPP-432) RemoteCache fixes for async methods and cleanup
- JDG-1288 (HRCPP-412) Added execute() method swig friendly
- JDG-1341 (HRCPP-417) Fixed args passing for remote exec
- HRCPP-405 getAll operation
- HRCPP-408 Multi listener needs more synch stuff
- JDG-1342 (HRCPP-418) correct response status processing
- HRCPP-381 Continuous queries
- HRCPP-403 Remove near cache listener when cm stops
- JDG-1306 fixed subsystem version
- JDG-1308 Added outdir for XML report
- JDG-1308 (HRCPP-401) Extended queries test suite
- HRCPP-380 EXTERNAL Auth for Windows
- HRCPP-376 SASL for Windows
- HRCPP-375 SASL for linux
- HRCPP-384 Calling unprivileged AddClientListener action leads to general exception
- HRCPP-388 HotRod operations hang indefinitely in the event of repeating exceptions
- HRCPP-397 cast port to unsigned
- HRCPP-373 Code cleanup and reduced complexity
- HRCPP-367 # shared_ptr in place of mixed ptr and ref style
- HRCPP-392 Build with openssl 1.1
- Update versions for JDG 7.2.0

* Fri Apr 07 2017 Jakub Senko <jsenko@redhat.com>
- HRCPP-369 Changed CertFindCertificateInStore for win7
- JDG-871 standalone.xml has misconfigured rest-connector element
- HRCPP-365 # Now near cache handles version correctly
- HRCPP-364 # lazy cache now
- HRCPP-345 # fix for openssl
- JDG-785: RHEL 7 C++ client issues in CMakeLists.txt and standalone-hotrod-ssl-client-auth.xml
- HRCPP-352 # Fix for ProtoStreamMarshaller
- HRCPP-351 # Fix get with protobuf
- HRCPP-284 # Client auth for openssl
- HRCPP-346 # More type supported in BasicMarshaller
- HRCPP-342 # Fixed memleaks on ssl test
- HRCPP-347 # Sending close notify in windows
- HRCPP-347 # Send close notify to peer
- HRCPP-341 # Fixed memleaks in nearCacheTest
- HRCPP-343 # Replaced portable:: with std::
- HRCPP-377 # Fix some memory leaks
- HRCPP-298 # Near cache implementation
- HRCPP-329 # fix for default switch
- HRCPP-296 # added querystring methods
- HRCPP-234 # added Expired Entry event
- HRCPP-237 # Fix for MSVC error
- HRCPP-320 # Fixed mem leak in marshaller
- HRCPP-322 # Cluster switch methods now same as Java
- JDG-568/HRCPP-319/Remove include of Transport.h in CacheClientListener.h
- HRCPP-287 # Events framework
- HRCPP-316 Refactored socket and transport
- HRCPP-315 # Pass failed servers to balancing
- HRCPP-312 # Fixed default value for forcedReturnValue
- HRCPP-297 # implementation for SChannel
- HRCPP-297 # SNI Implementation for openSSL
- HRCPP-310 # gitattributes to have only LF
- HRCPP-309 # Restore ConfigurationChildBuilder to fix the API
- JDG-510 (HRCPP-294) Fixed wrong marshaller::reset call
- JDG-462 (HRCPP-278) added missing method removeWithVersionAsync
- JGD-461 (HRCPP-277) fixed return type for putAsync
- HRCPP-308 Uncommented cpack call
- HRCPP-286 Added failover capabilities
- JDG-431 (HRCPP-275) javascript now uses the default cache and a fix for query
- HRCPP-265 TLS SChannel implementation
- HRCPP-283 Added exception if recv read 0 byte
- HRCPP-294 Fixed wrong marshaller::reset call
- HRCPP-278 Added missing async methods
- HRCPP-280 memleak TcpTransport::readBytes()
- HRCPP-276 Updated build with static protobuf 2.6.1
- HRCPP-275 javascript now uses the default cache and a fix for query
- HRCPP-272 Removed Builder<T>
- HRCPP-277 fixed return type for putAsync
- HRCPP-221 remove ServerNameId class

* Tue Jul 12 2016 Jakub Senko <jsenko@redhat.com>
- JDG-479 (HRCPP-280) memleak TcpTransport::readBytes()
- JDG-408 install protobuf executable as an executable program
- JDG-408 Include all protobuf libraries in the dist
- HRCPP-257 Fixed mem leak in runConcurrentCodecWritesTest
- HRCPP-260 exposed api for C# query, r_exec, ssl
- HRCPP-3 TLS support via OpenSSL
- HRCPP-253 Added HR query op and cmake to build it
- HRCPP-251 return same instance for same getCache request
- HRCPP-213 Add ProtoBuf generation machinery
- HRCPP-248 Implemented hotrod size op
- HRCPP-244 Fix to handle return value correctly
- HRCPP-238/compat warn the user if compat mode is enabled
- HRCPP-237 mandatory ping on startup
- HRCPP-207 Added asynchronous mode for get and put methods
- HRCPP-210/topology first implementation of Codec 2.0 topology
- HRCPP-239 add load of native lib in ConfigurationBuilder
- HRCPP-233 build script for windows
- HRCPP-234 fix compile error for windows
- HRCPP-221 Balancing strategy can now be implemented by the user
- HRCPP-232 Bump to 2.4 (some test skipped)
- HRCPP-231 fix lifespan and maxidle syntax
- HRCPP-216 Replaced hr_scoped_ptr with unique_ptr. Removed types.h
- HRCPP-226 replace hrbytes with std::vector
- HRCPP-226 rigged hrbytes as a vector<char>
- HRCPP-230 Updated test suite to 8.1.2. See also JDG-18
- HRCPP-208 execute() method implementation
- HRCPP-225 removed ScopedBuffer
- HRCPP-227 fix conditional compiling for windows
- HRCPP-220 updated requirements
- HRCPP-223 fix source zip package content
- HRCPP-222 fix number of retries
- JDG7 initial changes
- HRCPP-212 Minimal marshaller that speaks JBossMarshaller language
- HRCPP-219 Fix compilation issues on Mac OS X
- JDG7 release script
- HRCPP-209 Added codec up to 2.4 without topology evaluation and events
- Fix for bug HRCPP-215
- HRCPP-205 Fix wrong typedef
- HRCPP-204 Removed MurmurHash2 algorithm and ConsistentHashV1
- HRCPP-203 Replaced HR_SHARED_PTR with std::shared_ptr
- HRCPP-203 Update build environment for 8.0.0 release
- HRCPP-202 Implement maxTotal of ConnectionPoolConfigurationBuilder for C++ client
- HRCPP-201 Properly set sub-second socket timeouts
- HRCPP-198 Add infinispan.client.hotrod.max_retries equivalent
- HRCPP-197 C++ client failover does not work consistently
- HRCPP-196 The build script should have an option to build the test executables and link with prebuilt libraries
- HRCPP-195 BZ1228026 Message id should be threadsafe
- HRCPP-193 Access violation when linking against hotrod-static on Windows HRCPP-191 Cpp client test applications should link to the static library
- HRCPP-192 Add build scripts for Linux and Windows
- HRCPP-169 Windows socket code takes a long time to fail when connecting to a non-existent server
- HRCPP-173  The HotRod client should support a separate CH for each cache
- HRCPP-185 Enhance the InteractiveTest to allow users to work with multiple caches
- HRCPP-184 Memory leak when requesting non-existing caches
- HRCPP-179 ACCESS_VIOLATION when running the JNI tests on 32bit JVM on Windows
- HRCPP-177 Marshaller type error in getCache()
- HRCPP-171 Socket leak on failed connection attempt
- HRCPP-172 Clean-up IntWrapper - unused/undefined constructor
- HRCPP-170 Versioned value bytes ignored
- HRCPP-151 Do not use STL classes in public API
- HRCPP-146 Improve trace logging (synchronization fixes)
- HRCPP-164 Don't check idle connections if configured time between evictions is non-positive
- HRCPP-150 Always catch exceptions as const
- HRCPP-146 Improve trace logging
- HRCPP-147 Make the cmake configuration less brittle if Java is missing
- HRCPP-141 C++ client - protectect against calling cmake from the source directory
- HRCPP-140 Document building 64bit binaries and custom configurations on windows
- HRCPP-133 Reverting socket::read retry changes
- HRCPP-133 Modify retry handling in Socket::read
- HRCPP-134 Minor compiler fixes
- HRCPP-126 Segfault with cluster and connectionPool with minIdle > 0
- HRCPP-129 Reading data from the servers ocasionally timesout.
- HRCPP-127 Use a different name for the 32bit library
- HRCPP-125 ConfigurationBuilder not using the specified ValueSizeEstimate
- HRCPP-124 MetadataValue created and lastused fields should be -1 for immortal values
- HRCPP-123 Broken build on gcc 4.1.2 - compiler warning
- HRCPP-117: Add check that the RemoteCacheManager is started in putAll
- HRCPP-116 Windows sockets use strerror for WSA error codes
- HRCPP-115 valgrind tests fail with cmake 2.8.12 due to --log-file
- HRCPP-112 Fallback to non-preferred IP stacks if host can't be resolved with the preferred one
- HRCPP-114 ConnectionPool::invalidateObject does not remove object from queues
- HRCPP-113 InetSocketAddress operator< doesn't work OK for equal arguments
